package Forms::Sflang_sqla;

use strict;
use warnings;

use Wx::Perl::DbLinker::Wxform;

use Gtk2::Ex::DbLinker::SqlADataManager;
use Data::Dumper;
use Wx_dnav;

=for comment
The value comming from langid is used to display a combo and is also stored in a text field named langid1 in the xrc file.
The text field trigger a change event when records are navigate in the subform, but the combo does not.
The event is used to update the grid
=cut

use Wx qw[:everything];

sub new {
    my $class = shift;

    # , $href ) = @_;

    my %arg = ref $_[0] eq "HASH" ? %{ $_[0] } : (@_);
    my $self;
    @$self{qw(dnav_top)} = delete @arg{qw(dnav)};
    @$self{ keys %arg } = values(%arg);

=for comment
	  {
   	xrcfolder => $$href{xrcfolder},
	schema => $$href{schema},
	dnav_top => $$href{dnav},
	panel_to => $$href{panel_to},
	countryid => $$href{countryid},
   };
=cut

    $self->{log} = Log::Log4perl->get_logger(__PACKAGE__);
    $self->{log}->debug(" new form ");

    my $top_panel = $self->{dnav_top}
      ->load_panel( $self->{panel_to}, 'xrc/nav.xrc', 'm_dnav_panel' );

    my $path = $self->{xrcfolder} . "\\subform.xrc";
    $self->{dnav} = Wx_dnav->new( { ismain => 0, frame => $top_panel } );

    $self->{dnav}->load_panel( "m_panel_for_content", $path, "m_panel1" );
    $self->{dnav}->frame->SetBackgroundColour(wxLIGHT_GREY);

    $self->{dnav}->populate_widgets( $top_panel, [qw(b_add b_apply)] );

    $self->{log}->debug( "sform - populate_widgets 2d: "
          . join( " ", map { $_->GetName } @{ $self->{dnav}->{w2disable} } ) );
    $self->{log}->debug( "sform - populate_widgets: 2e: "
          . join( " ", map { $_->GetName } @{ $self->{dnav}->{w2enable} } ) );

#	my $rs = $self->{schema}->resultset('Speak')->search_rs({countryid => $self->{countryid}}, {columns => ['countryid', 'langid', {langid1 => 'langid'}]});
# (Dumper $rs->as_query);

    my $dman = Gtk2::Ex::DbLinker::SqlADataManager->new(
        dbh          => $self->{dbh},
        select_param => {
            -columns => [qw(langid langid|langid1 countryid)],
            -from    => "speaks",
            -where   => { countryid => $self->{countryid} }
        },
    );

    $self->{sform} = Wx::Perl::DbLinker::Wxform->new(
        data_manager        => $dman,
        builder             => $self->{dnav},
        auto_apply          => 0,
        datawidgets         => [qw(countryid langid langid1)],
        rec_spinner         => $self->{dnav}->get_object('RecordSpinner'),
        status_label        => $self->{dnav}->get_object('lbl_RecordStatus'),
        rec_count_label     => $self->{dnav}->get_object("lbl_RecordCount"),
        datawidgets_ro      => [qw(langid1)],
        datawidgets_changed => {
            langid1 => sub { on_langid1_changed( @_, $self ) }
        },
        after_update =>
          sub { on_after_update( $self, $self->{dnav}, $dman, "form" ); },
    );

    my $combodata = Gtk2::Ex::DbLinker::SqlADataManager->new(
        dbh          => $self->{dbh},
        select_param => {
            -from     => "langues",
            -where    => { -bool => "1=1" },
            -order_by => [qw(+langue)]
        }
    );

    $self->{sform}->add_combo(
        data_manager => $combodata,
        id           => 'langid',
        builder      => $self->{dnav},
    );

    #fields => [qw(langid langue)],

    $self->{sform}->get_data_manager->set_row_pos(0);
    $self->{langid} = $self->{sform}->get_data_manager->get_field('langid1');

    #die $self->{langid};
    my $list = Gtk2::Ex::DbLinker::SqlADataManager->new(
        dbh          => $self->{dbh},
        select_param => {
            -from  => "speaks",
            -where => {
                langid    => $self->{langid},
                countryid => { "!=" => $self->{countryid} }
            }
        }
    );

#set up the datasheet
#$top_panel = $self->{dnav}->load_panel('m_panel_for_grid', 'xrc/nav.xrc', 'm_dnav_panel');
    $top_panel = $self->{dnav}
      ->load_panel( 'm_panel_for_grid', 'xrc/nav.xrc', 'm_dnav_panel', wxCYAN );

    $self->{sf_list}->{dnav} =
      Wx_dnav->new( { ismain => 0, frame => $top_panel } );
    $self->{sf_list}->{dnav}
      ->populate_widgets( $top_panel, [qw(b_add b_apply)] );
    $self->{log}->debug(
        "grid - populate_widgets: "
          . join( " ",
            map { $_->GetName } @{ $self->{sf_list}->{dnav}->{w2disable} } )
    );

    #fieldnames => ["countryid", "country"],

#  renderer => "combo",	header_markup => "Country", data_manager=> $combodata, fieldnames => ["countryid", "country"],

    $combodata = Gtk2::Ex::DbLinker::SqlADataManager->new(
        dbh          => $self->{dbh},
        select_param => {
            -from     => "countries",
            -where    => { -bool => "1=1" },
            -order_by => [qw(+country)]
        }
    );

    my $dsparam = {
        data_manager => $list,
        fields       => [
            {
                name          => "countryid",
                renderer      => "combo",
                header_markup => "Country",
                data_manager  => $combodata,
                fieldnames    => [ "countryid", "country" ],
            },
            { name => "langid", renderer => "hidden" },

        ],
        after_update => => sub {
            on_after_update( $self, $self->{sf_list}->{dnav}, $list, "grid" );
        },

    };

#my $grid = $self->{dnav}->load_grid({ top_panel=> $top_panel, dest_name=>"m_panel_for_content", datasheet_param =>$dsparam});
    $self->{grid} = $self->{dnav}->load_grid(
        {
            bg              => wxCYAN,
            top_panel       => $top_panel,
            dest_name       => "m_panel_for_content",
            datasheet_param => $dsparam
        }
    );

    $self->{sf_list}->{dnav}->set_form( $self->{grid} );
    $self->{sf_list}->{dnav}
      ->connect_signal_for( "b_add", \&on_add_lst_clicked, $self );
    $self->{sf_list}->{dnav}
      ->connect_signal_for( "b_delete", \&on_delete_lst_clicked, $self );
    $self->{sf_list}->{dnav}
      ->connect_signal_for( "b_apply", \&on_apply_lst_clicked, $self );

    $self->{grid}->update;
    $self->{sform}->add_childform( $self->{grid} );

   # on_countryid_changed($self, $self->{sform}->get_widget_value('countryid'));
   # $sf_dnav->show_all_except([]);

    $self->{dnav}->show_all_except( [qw(langid1 countryid)] );
    $self->{dnav}->connect_signal_for( "b_add",    \&on_add_clicked,    $self );
    $self->{dnav}->connect_signal_for( "b_delete", \&on_delete_clicked, $self );
    $self->{dnav}->connect_signal_for( "b_apply",  \&on_apply_clicked,  $self );

    $self->{sform}->update;
    bless $self, $class;

}

sub on_countryid_changed {
    my ( $self, $value ) = @_;
    if ( !defined $value || $value eq "" ) {
        $self->{langid} = undef;
        $self->{dnav}->widgets_set_sensitivity( $self->{widgets}, 0 );

    } else {
        return if ( $value == $$self{countryid} );
        $self->{log}->debug("countryid_changed countryid : $value");
        $self->{countryid} = $value;

        $self->{sform}
          ->get_data_manager->query( -where => { countryid => $value } );

        #$self->{log}->debug("query in subform returned : " . $test);
        $self->{sform}->update;
        $value = $self->{sform}->get_widget_value("langid");
        $self->{log}
          ->debug( "langid: " . ( defined $value ? $value : " undef" ) );
        if ( $value != $self->{langid} ) {

            $self->{log}->debug("countryid_changed langid $value");

#$self->{grid}->get_data_manager->query(  $self->{schema}->resultset('Speak')->search_rs({langid => $value, countryid => {'!=' => $self->{countryid}} }) );
            $self->{grid}->get_data_manager->query(
                -where => {
                    langid    => $value,
                    countryid => { '!=' => $self->{countryid} }
                }
            );
            $self->{grid}->update;
        }

    }

}

sub on_after_update {
    my ( $self, $dnav, $dman, $where ) = @_;

    #my $rc = $self->{sform}->get_data_manager->row_count;
    my $rc = $dman->row_count;
    $self->{log}->debug( "on_after_update rc: " . $rc . " in " . $where );
    if ( $rc == 0 ) {
        $dnav->widgets_set_sensitivity(0);
    } else {
        $dnav->widgets_set_sensitivity(1);
    }

}

sub on_langid1_changed {
    my ( $b, $e, $self ) = @_;
    $self->{log}->debug( "langid1_changed current values  countryid: "
          . ( defined $self->{countryid} ? $self->{countryid} : " undef" )
          . " langid: "
          . ( defined $self->{langid} ? $self->{langid} : " undef" ) );

    #print Dumper($b);
    my $value = $b->GetLineText(0);
    $value = ( defined $value && $value eq "" ? undef : $value );
    if ( defined $value && $value != $self->{langid} )
    {    #query and update are called only when langid changes
        $self->{log}->debug("langid : $value");
        $self->{langid} = $value;

#$self->{grid}->get_data_manager->query( $self->{schema}->resultset('Speak')->search_rs({langid => $value, countryid => {'!=' => $self->{countryid}} })  );
        $self->{grid}->get_data_manager->query( -where =>
              { langid => $value, countryid => { '!=' => $self->{countryid} } }
        );
        $self->{grid}->update;

    } elsif ( !defined $value ) {
        $self->{log}->debug("setting langid to undef");
        $self->{langid} = undef;
        $self->{grid}->get_data_manager->query( -where =>
              { langid => $value, countryid => { '!=' => $self->{countryid} } }
        );
        $self->{grid}->update;
    }

}

sub on_delete_clicked {
    my ( $b, $self ) = @_;
    $self->{sform}->delete;
    $self->{deleting} = 1;
}

sub on_add_clicked {
    my ( $b, $self ) = @_;

    #die Dumper ($self->{countryid});
    $self->{sform}->insert;
    $self->{sform}->set_widget_value( "countryid", $self->{countryid} );
    $self->{dnav}->get_object("langid")->Enable(1);
    $self->{adding} = 1;
}

sub on_apply_clicked {
    my ( $b, $self ) = @_;
    if ( $self->{deleting} ) {
        $self->{sform}->apply;
        $self->{sform}->update;
        $self->{deleting} = 0;
        return;

    }
    my $value = $self->{sform}->get_widget_value('langid');
    my @pks   = $self->{sform}->get_data_manager->get_primarykeys;

    # modification of an existing record or addition of a new row
    #

    my $c = $self->{sform}->get_widget_value('countryid');
    return unless ( $c ne "" );
    $self->{log}->debug(
        "sform_apply country : " . $self->{countryid} . " langue : " . $value );

    #$self->{sform}->set_widget_value("langid1", $value);
    $self->{langid} = $value;
    my %h = ( countryid => $self->{countryid}, langid => $self->{langid} );

    # $self->{sform}->apply;
    $self->{sform}->get_data_manager->save(%h);

    $self->{sform}->apply( \@pks );
    $self->{sform}->get_data_manager->query(
        -where => { countryid => $self->{countryid} } );
    $self->{sform}->update;
    $self->{grid}->get_data_manager->query( -where =>
          { langid => $value, countryid => { '!=' => $self->{countryid} } } );
    $self->{grid}->update;
}

sub on_add_lst_clicked {
    my ( $b, $self ) = @_;
    return unless defined $self->{langid};

    #ajoute une ligne vide qu'il faut completer avec le pays
    $self->{grid}->insert(
        $self->{grid}->colnumber_from_name("langid") => $self->{langid} );

}

sub on_apply_lst_clicked {
    my ( $b, $self ) = @_;
    $self->{log}->debug("apply lst");
    if ( $self->{lst_deleting} ) {
        $self->{grid}->apply;
        $self->{lst_deleting} = 0;
        return;
    }

    my $dman = $self->{grid}->get_data_manager;
    my %old  = (
        countryid => $dman->get_field('countryid'),
        langid    => $dman->get_field('langid')
    );

    my %h = (
        langid    => $self->{langid},
        countryid => $self->{grid}->get_column_value('countryid')
    );
    $self->{log}->debug( "old values", Dumper %old );
    $self->{log}->debug( "new values", Dumper %h );
    my @pks = $dman->get_primarykeys;

#a new row is created in Datasheet->apply  and the inserting flag is turn to 1 (not in Datasheet->insert)
#so to instert a new row: calls Datasheet->aplly before saving in the new row with SqlADM->save
#passing the pk names to apply excludes these from being saved here
#since they are saved with the hashref  pass to DM->save
    $self->{grid}->apply( \@pks );
    $dman->save(%h);

    # $self->{sf_list}->apply(\@pks);

}

sub on_delete_lst_clicked {
    my $b    = shift;
    my $self = shift;
    $self->{lst_deleting} = 1;
    $self->{grid}->delete;
}

1;
